/**********************************************************************
 *	ATtiny2313 p Serial Line Bootloader
 **********************************************************************
 * vO~O̒Ӂi񑩁j:

 iPj0x06c0`0x07ff ܂ł̗̈悪u[g[_[̈łB
 iQju[g[_[0x06c0ԒnJnGg[łB
 iRjAvP[ṼGg[(reset vector)0x06bełB
---
 iSj`֐͑SďLBOOTLOADER_SECTIONɔzu܂B
 iTjcrt.S ɓȂ̂gp܂B
@@@ ̓Iɂ́A .dataZNV, .bssZNV̏؍s܂B
       āAiIȕϐiO[oWX^ϐ܂߂ājŁA
       lKvȂ̂main()֐̍ŏɑsĂȂƂȂ܂B
---
 iUjzXgobAvނƂ́A 0x06c0`0x07ff ܂łƁA
       0x0000`0x0001 ܂łύXȂ悤ȏ݂s܂B
 iVjāAAvP[ṼZbgxN^[ƓԒnɔrjmp߂
       0x6beԒnɒuKv܂B
 **********************************************************************
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

//#define	SPMEN SELFPRGE
//#define	BLBSET RFLB
#include <avr/boot.h>
#include <avr/wdt.h>
#include <stdint.h>

typedef	unsigned char uchar;
//
// <avr/boot.h>:
//	#define BOOTLOADER_SECTION	__attribute__ ((section	(".bootloader")))
// <avr/iotn2313.h>
//	#define SPM_PAGESIZE    32
//

#define	BAUD	19200

#ifndef	F_CPU
#define	F_CPU	8000000		//CPUNbNg	8MHz
#endif

//	BOOTMODE JUMPERɂ郆[U[AvP[Vւ̕@Q.
#define	BOOT_JUMPER_ASM	1	// asmLq.
#define	BOOT_JUMPER_C	0	// b Lq.

#define	BOOT_USE_WDT	0	// wdtɂ郊Zbg̎s.


#define	ECHOBACK_TEST	0

enum {
 CMD_FLASH=1,
 CMD_READ,
 CMD_BOOT,
};

#define	UART_BAUD_CALC(BAUD_RATE) ((uint16_t)(((F_CPU)/((BAUD_RATE*8.0))+0.5)-1))

#define	ACK		'a'
#define	NACK	'n'

/**********************************************************************
 *	
 **********************************************************************
 */

static void delay_100us(uchar us100) BOOTLOADER_SECTION;
static void delay_loop(uchar __count) BOOTLOADER_SECTION;
static void	 sendchar(char data) BOOTLOADER_SECTION;
static uchar readchar(void) BOOTLOADER_SECTION;
static void readsync(void) BOOTLOADER_SECTION;
static void flash_pgmem(void) BOOTLOADER_SECTION;
static void read_pgmem(void) BOOTLOADER_SECTION;
static void exec_boot(void) BOOTLOADER_SECTION;
static void bootload(void) BOOTLOADER_SECTION;
static void ack(void) BOOTLOADER_SECTION;
static void nack(void) BOOTLOADER_SECTION;
int	   main(void) BOOTLOADER_SECTION;


#if	0
typedef	struct {
	uchar cmd;
	int   addr;
	uchar csum;
} HDR;

static	HDR hdr;
#endif



register uchar checksum   asm("r3");

register uchar hdr_cmd    asm("r4");
//register uchar hdr_csum   asm("r5");
register int   hdr_addr   asm("r6");

/**********************************************************************
 *	4 * __count  cycles ԑ҂.
 **********************************************************************
 */
static	void delay_loop(uchar __count)
{
	__asm__ volatile (
		"1: dec %0" "\n\t"
		"nop\n\t"
		"brne 1b"
		: "=r" (__count)
		: "0" (__count)
	);
}
/**********************************************************************
 *	
 **********************************************************************
 */
static void delay_100us(uchar us100)
{
	while(us100) {
		delay_loop(200);
		us100--;
	}
}
/**********************************************************************
 *	R}h:   'b' , 'x'
 **********************************************************************
 */
static	void readsync(void)
{
	uchar c;

	while(1) {
		do {
			c = readchar();
		}while(c != 'b');
redo:
		c = readchar();
		if(c=='x') return;	// OK.
		if(c=='b') goto redo;
	}
}

/**********************************************************************
 *	
 **********************************************************************
 */
static void	sendchar(char data)
{
	delay_100us(8);	// 400uS
	loop_until_bit_is_set(UCSRA,UDRE);
	UDR	= data;
}

/**********************************************************************
 *	
 **********************************************************************
 */
static uchar readchar(void)
{
	uchar c;
	loop_until_bit_is_set(UCSRA,RXC);
	c = UDR;
	checksum += c;
	return c;
}

/**********************************************************************
 *	
 **********************************************************************
 */
static	inline void ack(void)
{
	sendchar(ACK);
}
static	inline void nack(void)
{
	sendchar(NACK);
}
/**********************************************************************
 *	
 **********************************************************************
 */
static void flash_pgmem(void)
{
	uchar i,lo,hi;
	uchar ack_chr;
	int p = hdr_addr;	//hdr.addr;
	for(i=0;i<32/2;i++) {
		lo=readchar();
		hi=readchar();
		boot_page_fill(p,lo|(hi<<8));
		p += 2;
	}

	p -= 32;
	if(checksum == 0) {
		boot_page_erase(p);
		boot_spm_busy_wait();

		boot_page_write(p);
		boot_spm_busy_wait();

		ack_chr = ACK;
	}else{
		ack_chr = NACK;
	}
	sendchar(ack_chr);
}

/**********************************************************************
 *	
 **********************************************************************
 */
static void read_pgmem(void)
{
	uchar i;
	int p = hdr_addr;	//hdr.addr;
	for(i=0;i<32;i++) {
		sendchar(pgm_read_byte(p++));
	}
}

/**********************************************************************
 *	
 **********************************************************************
 */
static void exec_boot(void)
{
	ack();
#if	BOOT_USE_WDT
	wdt_enable(WDTO_30MS);
	while(1); // Wait for doomsday
#else
	__asm__ volatile (
		"rjmp user_prog\n"
	);
#endif
}

/**********************************************************************
 *	[_[::C
 **********************************************************************
 */
static void bootload(void)
{
	uchar lo,hi;

	readsync();
	checksum = 0;
#if	0
	uchar i;
	uchar *p = (uchar *) &hdr;
	for(i=0;i<4;i++) {
		p[i]=readchar();
	}
#endif
	hdr_cmd  = readchar();

	lo  = readchar();
	hi  = readchar();
	hdr_addr = lo|(hi<<8);
//	hdr_csum = 
			readchar();

	switch(hdr_cmd) {
	  case CMD_FLASH:
		flash_pgmem();
	  	break;
	  case CMD_READ:
		read_pgmem();
	  	break;
	  case CMD_BOOT:
		exec_boot();
	  	break;
	  default:
		nack();
	  	break;
	}
}


/**********************************************************************
 *	C
 **********************************************************************
 */

int	main(void)
{
	cli(); // no irqs.
	DDRD  = 0;
	PORTD = 0b00000100;				// PD2 = BOOT JUMPER (LOW close=BOOT) PULLUP
	DDRB  = 0b00001100;				// PB2,3=READY,BUSY LED  , DIRECTION
	PORTB = 0;

	// set Baud
	UBRRH=UART_BAUD_CALC(BAUD)>>8;
	UBRRL=UART_BAUD_CALC(BAUD)&0xFF;
	
	UCSRA =	_BV(U2X);				// at Double Speed
	UCSRC =	_BV(UCSZ0)|_BV(UCSZ1);	// with	8N1	Frames
	UCSRB =	_BV(TXEN) |	_BV(RXEN);	// Transmitter + Receiver enable
	
#if	BOOT_JUMPER_ASM
	//if((PIND & 0b00000100)) 
	{
		__asm__ volatile (
			"sbic	0x10,2\n"
			"rjmp user_prog\n"
		);
	}
#endif

#if	BOOT_JUMPER_C
	if((PIND & 0b00000100)) {
		user_prog();
	}
#endif

#if	ECHOBACK_TEST
	while (1) {
		sendchar(readchar());
	}
#else
	while (1) {
		bootload();
	}
#endif
}

/**********************************************************************
 *	
 **********************************************************************

 Tv

 ERxD/TxDڑɂȈՃu[g[_[.

 vgR

 (PC->AVR)
      Sync[2]     :  'b','x'

iPjFlash̏(32byteŒTCY)

 (PC->AVR)
      Preamble[4] :  CMD_FLASH,addr_l,addr_h,csum
      Data[32]    :   raw_data[32]
 (AVR->PC)
      ACK         :  'a'
      NACK        :  'n'

iQjFlash̓ǂݍ(32byteŒTCY)
 (PC->AVR)
      Preamble[4] :  CMD_READ,addr_l,addr_h,csum
 (AVR->PC)
      Data[32]    :   raw_data[32]


iRjReset
 (PC->AVR)
      Preamble[4] :  CMD_EXEC,addr_l,addr_h,csum
 (AVR->PC)
      ACK         :  'a'

 */
/**********************************************************************
 *	
 **********************************************************************
 */
