/*********************************************************************
 *	USBoR̃^[Qbg[ANZX
 *********************************************************************
 *API:
 *
 *֐:
void	dumpmem(int adr,int cnt);
void	pokemem(int adr,int data0,int data1);
void	memdump_print(void *ptr,int len,int off);
 */


#include <windows.h>
#include <stdio.h>
#include <time.h>

#include "loader.h"
#include "rs232c.h"
#include "util.h"

#define	VERBOSE	0
#define	TIMEOUT	2000

#define	if_V	if(VERBOSE)

enum {
 CMD_FLASH=1,
 CMD_READ,
 CMD_BOOT,
};

#define	UART_BAUD_CALC(BAUD_RATE) ((uint16_t)(((F_CPU)/((BAUD_RATE*8.0))+0.5)-1))

#define	ACK		'a'
#define	NACK	'n'


/****************************************************************************
 *	[e_v.
 ****************************************************************************
 *	void *ptr : _vf[^.
 *	int   len : _voCg.
 *	int   off : ^[Qbg̔Ԓn\.
 */
void memdump_print(void *ptr,int len,int off)
{
	unsigned char *p = (unsigned char *)ptr;
	int i,j,c;

	for(i=0;i<len;i++) {
		if( (i & 15) == 0 ) printf("%06x", ((int)p - (int)ptr + off) & 0xffffff);
		printf(" %02x",*p);p++;
		if( (i & 15) == 15 )
		{
#if	1	// ASCII DUMP
			printf("  ");
			for(j=0;j<16;j++) {
				c=p[j-16];
				if(c<' ') c='.';
				if(c>=0x7f) c='.';
				printf("%c",c);
			}
#endif
			printf("\n");
		}
	}
	printf("\n");
}


static void	rs_cmdsync(void)
{
	RS_putc(0xff);
	RS_putc(0xff);
	RS_putc(0xff);
	RS_putc(0xff);
}

static void	rs_putcmd(int cmd,int adr,int sum32)
{
	int i;
	uchar buf[16];


	RS_putc('b');
	RS_putc('x');
	// ---  checksumL ---
	buf[0]=cmd;
	buf[1]=adr;
	buf[2]=adr>>8;
	buf[3]=0;
	
	for(i=0;i<4;i++) {
		sum32 += buf[i];
	}
	buf[3] = (-sum32);	//f[^I[܂ł̑aOɂȂׂ.

	for(i=0;i<4;i++) {
		RS_putc(buf[i]);
	}
}

/*********************************************************************
 *
 *********************************************************************
 */
int UsbBootTarget(int adr,int boot)
{
	int c;
	rs_putcmd(CMD_BOOT,adr,0);
	c = RS_getc( TIMEOUT );
	return 1;
}

/*********************************************************************
 *	^[Qbg[Aǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	uchar         *buf :ǂݎobt@.
 *	int           size :ǂݎTCY.
 *߂l
 *	-1    : s
 *	̒l: .
 */
int UsbRead(int adr,int arena,uchar *buf,int size)
{
	int i,c;

	rs_putcmd(CMD_READ,adr,0);
	for(i=0;i<32;i++) {
		c = RS_getc( TIMEOUT );
		if(c== -1) {
			printf("rs232c TIMEOUT!\n");
			return -1;
		}
		*buf++ = c;
	}
	Sleep(14);
	return 0;
}
/*********************************************************************
 *	^[Qbg[1oCgǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
int UsbPeek(int adr,int arena)
{
	unsigned char buf[16];
	int size=1;
	int rc = UsbRead(adr,arena,buf,size);
	if( rc != size) {
		return -1;
	}
	return buf[0];
}

/*********************************************************************
 *
 *********************************************************************
 */
int 	UsbEraseTargetROM(int adr,int size)
{
	return 0;
}

/*********************************************************************
 *	^[QbgFlashe(32oCg܂).
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int           data :݃f[^.
 *	int           mask :ݗLrbg}XN.
 *
 *  mask  = 0 ̏ꍇ͑SrbgL ()
 *	mask != 0 ̏ꍇ́Amaskrbg1ɑΉdatâݍXVA͕ύXȂ.
 */
int UsbFlash(int adr,int arena,uchar *buf,int size)
{
	int i,c,sum32=0;

	for(i=0;i<32;i++) {
		sum32 += (buf[i]);
	}


	rs_putcmd(CMD_FLASH,adr,sum32);
	for(i=0;i<32;i++) {
		RS_putc(buf[i]);
	}

	c = RS_getc( TIMEOUT );
	printf("ACK=%x(%c)\n",c,c);
	Sleep(12);
	return 0;
}

int UsbInit(int verbose, int baud, char *comport)
{
	int rc = RS_init(comport,baud);

	rs_cmdsync();

	return rc;
}
int UsbExit(void)
{
	RS_exit();
	return 0;
}
